let
  fromEnv = var: def:
    let val = builtins.getEnv var; in
    if val != "" then val else def;
in rec {
  shell = "/nix/store/nxj1v1i38s984lxx8xmn2ynajhygni0n-bash-4.4-p23/bin/bash";
  coreutils = "/nix/store/cad9h65mxzsj3f30w0dwaj3m63bg20d4-coreutils-8.32/bin";
  bzip2 = "/nix/store/9b954d4vxfxf174c6kgv1y2ab5pjwcvp-bzip2-1.0.6.0.2-bin/bin/bzip2";
  gzip = "/nix/store/nccxk2ksq2jngkah1pjrxqav64djam8r-gzip-1.10/bin/gzip";
  xz = "/nix/store/9limniw3y9cxdmw7rmqrfw821grwplvw-xz-5.2.5-bin/bin/xz";
  tar = "/nix/store/4laij1iccn5fymnf8zy8viiv49qi47hy-gnutar-1.34/bin/tar";
  tarFlags = "--warning=no-timestamp";
  tr = "/nix/store/cad9h65mxzsj3f30w0dwaj3m63bg20d4-coreutils-8.32/bin/tr";
  nixBinDir = fromEnv "NIX_BIN_DIR" "/nix/store/s0r2rv72br8bhn6hkknsz8qhpbbyj17q-nix-2.3.17/bin";
  nixPrefix = "/nix/store/s0r2rv72br8bhn6hkknsz8qhpbbyj17q-nix-2.3.17";
  nixLibexecDir = fromEnv "NIX_LIBEXEC_DIR" "/nix/store/s0r2rv72br8bhn6hkknsz8qhpbbyj17q-nix-2.3.17/libexec";
  nixLocalstateDir = "/nix/var";
  nixSysconfDir = "/etc";
  nixStoreDir = fromEnv "NIX_STORE_DIR" "/nix/store";

  # If Nix is installed in the Nix store, then automatically add it as
  # a dependency to the core packages. This ensures that they work
  # properly in a chroot.
  chrootDeps =
    if dirOf nixPrefix == builtins.storeDir then
      [ (builtins.storePath nixPrefix) ]
    else
      [ ];
}
